#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

int _a;
int _b;
long _mini;
long _maxi;
__int128 _round;
long _power;

void initializeA( int a, int b )
{
	_a = a;
	_b = b;

	_round = 1L;
	_round = _round << (b-1);
	_power = 1L << b;

	_mini = 1L << (a+b);
    _maxi = _mini - 1L;
    _mini = -_mini;
}

long setNumber( double v )
{
	return ( (long)(v*_power) );
}

double getNumber( long r )
{
	return ( (double)r/_power);
}

long mulTrunc( long x, long y )
{
	__int128 r;
	__int128 a=0;
	__int128 b=0;

	a = x;
	b = y;

	// r = a*b + _round;
	r = a*b;
	r = r>>_b;

	return( r );
}


int main(int argc, char *argv[])
{
	FILE *fp;
	char nombre[81];
	unsigned char codigomapa[8];
	unsigned char buf[16];
	int i, j, k, jj, nbits;
	int bits;
	long xi, xni, yi, yni;
	long ai[12];

	long vi[3];
	int codigo[6];
	int i1, i2, i3;
	long mem[3][2];
	long memas[6];

	if( argc != 7 ) {
		fprintf( stderr, "Args: x0 y0 abaaba bits nbits_a_generar archivo_salida\n" );
		fprintf( stderr, "      a: [0|1], b: [0|1|2]\n" );
		return 1;
	}
	strncpy( codigomapa, argv[3], 7 );
	bits =  (int)strtol( argv[4], (char **)NULL, 10);
	if ( bits > 60 ) {  // 1 + 62 = 63.   4 + 59 = 63 
		printf("Bits solo puede ser menor que 60\n");
		return 1;
	}
	nbits = (int)strtol( argv[5], (char **)NULL, 10);	
	strncpy( nombre, argv[6], 80 );

	if ( (fp=fopen( nombre, "w"))==NULL ) {
		fprintf ( stderr, "ERROR: Can't open output file: %s\n", nombre );
		return 1;
	}
	
	initializeA( 3, bits );

	xi = 0xf800000000000000 + strtol( argv[1], (char **)NULL, 16 );
	yi = 0xf800000000000000 + strtol( argv[2], (char **)NULL, 16 );
	printf("# xni: %lx\n", xi );
	printf("# yni: %lx\n", yi );

	for( i=0; i<6; i++ )
		codigo[i] = codigomapa[i] - '0';
	for( i=0; i<6; i++ )
		printf( "%d", codigo[i] );
	printf("\n");

	// ai[0] = setNumber( -0.6 );
	// ai[1] = setNumber( -0.1 );
	// ai[2] = setNumber(  1.1 );
	ai[0] = 0xf666666666666666;
	ai[1] = 0xfe66666666666666;
	ai[2] = 0x1199999999999999;

	// ai[3] = setNumber(  0.2 );
	// ai[4] = setNumber( -0.8 );
	// ai[5] = setNumber(  0.6 );
	ai[3] = 0x0333333333333334;
	ai[4] = 0xf333333333333333;
	ai[5] = 0x0999999999999999;

	// ai[6] = setNumber( -0.7 );
	// ai[7] = setNumber(  0.7 );
	// ai[8] = setNumber(  0.7 );
	ai[6] = 0xf4cccccccccccccd; 
	ai[7] = 0x0b33333333333333;
	ai[8] = 0x0b33333333333333;

	// ai[9] = setNumber(  0.3 );
	// ai[10] = setNumber( 0.6 );
	// ai[11] = setNumber( 0.9 );
	ai[9] =  0x04cccccccccccccc;
	ai[10] = 0x0999999999999999;
	ai[11] = 0x0e66666666666667;

	memas[0] = ai[2];
	memas[1] = ai[3];
	memas[2] = ai[5];
	memas[3] = ai[8];
	memas[4] = ai[9];
	memas[5] = ai[11];

	for(i=0, j=0; i < nbits; i+=16){
		mem[0][0] = xi;
		mem[0][1] = xi;
		mem[1][0] = xi;
		mem[1][1] = yi;
		mem[2][0] = yi;
		mem[2][1] = yi;

		// xni = ai[0] + mulTrunc(ai[1],xi) + mulTrunc(ai[2],x2i) + mulTrunc(ai[3],xyi) +
		//               mulTrunc(ai[4],yi) + mulTrunc(ai[5],y2i);
		xni = ai[0] + mulTrunc(ai[1],xi);
		for( k=0; k<3; k++ ) { 
			i1 = codigo[k];
			i2 = (i1+1)%3;
			i3 = (i2+1)%3;

			vi[0] = memas[ k ];
			vi[1] = mem[ k ][0];
			vi[2] = mem[ k ][1];

			xni += mulTrunc( mulTrunc( vi[i1], vi[i2] ),  vi[i3] );
		}
		xni +=	mulTrunc(ai[4],yi);

		// yni = ai[6] + mulTrunc(ai[7],xi) + mulTrunc(ai[8],x2i) + mulTrunc(ai[9],xyi) +
		//               mulTrunc(ai[10],yi) + mulTrunc(ai[11],y2i);
		yni = ai[6] + mulTrunc(ai[7],xi);
		for( k=3; k<6; k++ ) { 
			i1 = codigo[k];
			i2 = (i1+1)%3;
			i3 = (i2+1)%3;

			vi[0] = memas[ k ];
			vi[1] = mem[ k-3 ][0];
			vi[2] = mem[ k-3 ][1];

			yni += mulTrunc( mulTrunc( vi[i1], vi[i2] ),  vi[i3] );
		}
		yni +=  mulTrunc(ai[10],yi);

		xi = xni;
		yi = yni;

		// printf("%lf %lf\n", getNumber( xi ), getNumber( yi ) ); 

		// Eight bits obtained every cycle:
		buf[j] = (unsigned char)( xni & 0x00000000000000ff );
		j++;
		buf[j] = (unsigned char)( yni & 0x00000000000000ff );
		j++;

		
		if( j == 16 ) {
			j = 0;
			if ( fwrite ( buf, 1, 16, fp) != 16 ) {
				fprintf ( stderr, "ERROR: writing file: %s\n", nombre );
				return 1;
			}
		} 
	}

	if ( j > 0 ) {
		if ( fwrite ( buf, 1, j, fp) != j ) {
			fprintf ( stderr, "ERROR: writing file: %s\n", nombre );
			return 1;
		}
	}
	fclose( fp );

	return 0;
}
