

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

use ieee.std_logic_signed.all;

entity mapa_Sprott_simple is
generic(
	    n: integer:= 64;
        entero: integer:= 4;
        fraccional: integer:=60);
    Port ( clk, rst : in STD_LOGIC;
  
    xi_in: in std_logic_vector(n-1 downto 0);
    start : in std_logic;
      start_spi : in std_logic;
    xn, yn: out std_logic_vector(8-1 downto 0);
     --   xn, yn: out std_logic_vector(n-1 downto 0);

    new_out: out std_logic;
    comb_sel:in  std_logic_vector(2 downto 0));
end mapa_Sprott_simple;

architecture Behavioral of mapa_Sprott_simple is
 
signal  resul1x, resul2x, resul3x, resul4x, resul5x, resul1y, resul2y, resul3y, resul4y, resul5y : std_logic_vector(n-1 downto 0);
signal xi, yi, xn_al, yn_al: std_logic_vector(n-1 downto 0);

signal  res1x, res2x, res3x, res4x, res5x, res6x : std_logic_vector(n-1 downto 0);
constant yi_in: std_logic_vector(n-1 downto 0):=x"f666666666666680";

constant a1: std_logic_vector(n-1 downto 0):=x"f666666666666680";
constant a2: std_logic_vector(n-1 downto 0):=x"fe66666666666660";
constant a3: std_logic_vector(n-1 downto 0):=x"1199999999999a00";
constant a4: std_logic_vector(n-1 downto 0):=x"0333333333333340";
constant a5: std_logic_vector(n-1 downto 0):=x"f333333333333300";
constant a6: std_logic_vector(n-1 downto 0):=x"0999999999999980";
constant a7: std_logic_vector(n-1 downto 0):=x"f4cccccccccccd00";
constant a8: std_logic_vector(n-1 downto 0):=x"0b33333333333300";
constant a9: std_logic_vector(n-1 downto 0):=x"0b33333333333300";
constant a10: std_logic_vector(n-1 downto 0):=x"04ccccccccccccc0";
constant a11: std_logic_vector(n-1 downto 0):=x"0999999999999980";
constant a12: std_logic_vector(n-1 downto 0):=x"0e66666666666680";
signal sel_aux1 : std_logic_vector(1 downto 0);
signal bandera, bandera2, start_reg: std_logic_vector(1 downto 0 );
begin

with comb_sel(2) select sel_aux1<= "10" when '0',  "00" when others;


--with start select xi<= xi_in when '0',  "00" when others;

process (clk, rst, start, start_reg, bandera, bandera2)
begin

if rst='1' then 
    xi<= (others=>'0');
    yi<= (others=>'0');
    bandera<="00";
     bandera2<="00";
   -- start_reg<='0';
    new_out<='0';
        xn<= (others=>'0');
        yn<= (others=>'0');
elsif rising_edge(clk)  and start_spi='1' then
--xi<=xi;
--yi<=yi; 
--start_reg<=start;
    bandera<=bandera+1;
        new_out<='0';
    if start='1' then 
        xi<= xi_in;
        yi<= yi_in;
       -- xn<= (others=>'0');
       -- yn<= (others=>'0');
        bandera<="00";
        bandera2<=bandera2+1;
        if bandera2="11" then 
           bandera2<="00";
           new_out<='1';
           xn<= xn_al(7 downto 0);
           yn<= yn_al(7 downto 0);
        end if;
    elsif bandera="10" then 
        xi<= xn_al;
        yi<= yn_al;
        bandera<="00";
        new_out<='1';
        xn<= xn_al(7 downto 0);
        yn<= yn_al(7 downto 0);
    end if;

end if;

end process;





 mul1ab: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>a3,
    b=>xi,
    resul=>res1x,
    clk=>clk,
    rst=>rst
);

 mul1cb: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>res1x,
    b=>xi,
    resul=>resul2x,
    clk=>clk,
    rst=>rst
);

	

 mul2ab: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>a4,
    b=>xi,
    resul=>res2x,
    clk=>clk,
    rst=>rst
);

 mul2cb: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>res2x,
    b=>yi,
    resul=>resul3x,
    clk=>clk,
    rst=>rst
);
	



 mul3ab: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>a6,
    b=>yi,
    resul=>res3x,
    clk=>clk,
    rst=>rst
);

 mul3cb: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>res3x,
    b=>yi,
    resul=>resul5x,
    clk=>clk,
    rst=>rst
);
	
		

multi1: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>a2,
    b=>xi,
    resul=>resul1x,
    clk=>clk,
    rst=>rst
);



multi2: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>a5,
    b=>yi,
    resul=>resul4x,
    clk=>clk,
    rst=>rst
);	


xn_al<= a1 +  resul1x + resul2x + resul3x+ resul4x+resul5x;






 mul1aby: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>a9,
    b=>xi,
    resul=>res4x,
    clk=>clk,
    rst=>rst
);

 mul1cby: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>res4x,
    b=>xi,
    resul=>resul2y,
    clk=>clk,
    rst=>rst
);

	

 mul2aby: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>a10,
    b=>xi,
    resul=>res5x,
    clk=>clk,
    rst=>rst
);

 mul2cby: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>res5x,
    b=>yi,
    resul=>resul3y,
    clk=>clk,
    rst=>rst
);
	



 mul3aby: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>a12,
    b=>yi,
    resul=>res6x,
    clk=>clk,
    rst=>rst
);

 mul3cby: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>res6x,
    b=>yi,
    resul=>resul5y,
    clk=>clk,
    rst=>rst
);
	

		

multi1y: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>a8,
    b=>xi,
    resul=>resul1y,
    clk=>clk,
    rst=>rst
);



multi2y: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>a11,
    b=>yi,
    resul=>resul4y,
    clk=>clk,
    rst=>rst
);	


yn_al<= a7 +  resul1y + resul2y + resul3y+ resul4y+resul5y;



end Behavioral;
