
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity Multi_axbxc64 is
generic(
	    n: integer:= 64;
        entero: integer:= 4;
        fraccional: integer:=60);
	port(
        CLK, RST: in std_logic;
        comb_sel: in std_logic_vector(1 downto 0);
        A, B,C: in std_logic_vector(n-1 downto 0);
        resul: out std_logic_vector(n-1 downto 0)-- := (others => '0')
	);
end Multi_axbxc64;

architecture Behavioral of Multi_axbxc64 is
signal mux_M1a, mux_M1b, mux_M2b, res_M1: std_logic_vector(n-1 downto 0);
begin


--mux_M1a<=a;
--mux_M1b<=b;

--mux_M2b<=c;


with comb_sel(1) select mux_m1a<= a when '0',  c when others;

with comb_sel(0) select mux_m1b<= b when '0',  c when others;

with comb_sel select mux_m2b<= c when "00", b   when "01",  a when others;


multi1: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>mux_M1a,
    b=>mux_M1b,
    resul=>res_M1,
    clk=>clk,
    rst=>rst
);



multi2: entity work.multiplier_PF_rond64 
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>res_M1,
    b=>mux_M2b,
    resul=>resul,
    clk=>clk,
    rst=>rst
);
end Behavioral;
