
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_signed.all;


entity OscLu_correcto is
generic(    n: integer:= 24;
            entero: integer:= 4;
            fraccional: integer:=20);
    Port (  rst, clk, start: in STD_LOGIC;
    comb_sel: in STD_LOGIC_vector(7 downto 0);
    X_IN: IN std_logic_vector(n-1 downto 0);
            x_out, y_out, z_out: out std_logic_vector(n-1 downto 0);
            new_out: out std_logic);
end OscLu_correcto;

architecture Behavioral of OscLu_correcto is
signal  z, f, ff, f1, f2, f3, f4, v, f_al1,f_al2: std_logic_vector(n-1 downto 0);
signal res_MR1, res_MR2, res_sc8,  res_sw, vv, res_mxx, res_CBS: std_logic_vector(n-1 downto 0);
signal xtemp, ytemp: std_logic_vector(n-1 downto 0);-- no segura de necesitarlo
--signal comb_sel_al: std_logic_vector(7 downto 0);
signal guardar: std_logic;
signal s_al, s: std_logic_vector(n-1 downto 0);

signal x: std_logic_vector(n-1 downto 0):=x"000000";
signal y: std_logic_vector(n-1 downto 0):=x"000000";

constant h: std_logic_vector(n-1 downto 0):=x"000418";

constant m: std_logic_vector(n-1 downto 0):=x"004395";

constant w: std_logic_vector(n-1 downto 0):=x"099999";

constant winv: std_logic_vector(n-1 downto 0):=x"1aaaaa";

constant k: std_logic_vector(n-1 downto 0):=x"04cccc";


constant a: std_logic_vector(n-1 downto 0):=x"0b3333";
constant b: std_logic_vector(n-1 downto 0):=x"0b3333";
constant c: std_logic_vector(n-1 downto 0):=x"0b3333";

constant d1: std_logic_vector(n-1 downto 0):=x"0b3333";


constant c5: std_logic_vector(n-1 downto 0):=x"b00000";--  -5
constant c4: std_logic_vector(n-1 downto 0):=x"400000"; --   4
constant c2: std_logic_vector(n-1 downto 0):=x"200000";
constant c0: std_logic_vector(n-1 downto 0):=x"000000";
constant c7: std_logic_vector(n-1 downto 0):=x"000001";
constant c6: std_logic_vector(n-1 downto 0):=x"f00001";
constant c8: std_logic_vector(n-1 downto 0):=x"099999";

constant cB: std_logic_vector(n-1 downto 0):=x"00288d";   --m*w
constant f2_al: std_logic_vector(n-1 downto 0):=x"00288d";   --m*w


constant cBmh: std_logic_vector(n-1 downto 0):=x"09710c";   --   c8-m*h
constant c2alpha: std_logic_vector(n-1 downto 0):=x"1ffbe8"; -- 1ff7ce


signal cnt: std_logic_vector(2 downto 0);




signal xx: std_logic_vector(n-1 downto 0);


type state_type is (idle, oscilar, stop);
signal state : state_type := idle;


begin







fg: process (clk, start, cnt)
	begin

		if(rising_edge(clk))then
			case state is
	
			when idle =>
			    cnt<=(others=>'0');
                guardar<='0';
                x<=x"019999";
                y<=x"019999";
                z<=x"019999";
                if (start = '1') then 
					x<=x_in;
                    y<=x"019999";
                    z<=x"019999";
					state <= oscilar;
				else
					state<=idle;
				end if;
				new_out<='0';
			
			when oscilar =>
				 cnt<=cnt+1;
                 --guardar<='0';
				if cnt="101" then 
                    x<=xtemp;
                    y<=ytemp;
                    z<=z-f1-f2-f3+f4;
                    cnt<=(others=>'0');
                    state <= stop;
                    new_out<='1';
				else
					state<=oscilar;
				end if;
			
			when stop =>
			new_out<='0';
			     if start='1' then 
			       state <= oscilar;
				else
					state<=stop;
				end if;
				
			
			end case;
		end if;
	end process fg;





MUL_RON1: entity work.multiplier_PF_rond -- mulRound(hlpha,y);
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>h,
    b=>y,
    resul=>res_MR1,
    clk=>clk,
    rst=>rst
);


MUL_RON2: entity work.multiplier_PF_rond  --mulRound(h,z);
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>h,
    b=>z,
    resul=>res_MR2,
    clk=>clk,
    rst=>rst
);


xtemp<=x + res_MR1;
ytemp<=y + res_MR2;


 
vabs: entity work.abs_x 
generic map(    n=>n)
  Port map (    x => x,
                xx => xx);






MUL_RON2xx: entity work.multiplier_PF_rond  --mulRound(h,z);
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>xx,
    b=>winv,
    resul=>s_al,
    clk=>clk,
    rst=>rst
);


--s <= c4 when s_al(n-1 downto n-2) = "01" else  s_al(n-1 downto n-4)&x"00000" ;  
s <=  s_al(n-1 downto n-4)&x"00000"    when s_al(n-1 downto n-2) = "00"  else  c4;  

--  00   s<= s_al&mask 
--  01   s<= c4 
--  10   s<=  s_al&mask 
-- 11     s<=  s_al&mask 

-- verificar si no tendro que cubri el caso que sea mas de 4 o sea 11 

MUL_sw: entity work.multiplier_PF_rond  --mulRound(h,z);
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>s,
    b=>w,
    resul=>res_sw,
    clk=>clk,
    rst=>rst
);



v<=xx - res_sw;

vabs_v: entity work.abs_x 
generic map(    n=>n)
  Port map (    x => v,
                xx => vv);





MUL_mxx: entity work.multiplier_PF_rond  --mulRound(m,xx); f1
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>m,
    b=>xx,
    resul=>res_mxx,
    clk=>clk,
    rst=>rst
);

--f2 es constante porque es m*w

MUL_f3s: entity work.multiplier_PF_rond  --mulRound(m*w,s); f3
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>f2_al,
    b=>s,
    resul=>res_CBS,
    clk=>clk,
    rst=>rst
);





MUL_RONc8: entity work.multiplier_PF_rond  --mulRound(s,c8);
generic map (
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>s,
    b=>c8,
    resul=>res_sc8,
    clk=>clk,
    rst=>rst
);



f_al1<=res_sC8+k;
f_al2<=res_mxx- res_CBS + res_sC8;





process(vv,s,clk)
begin
if rising_edge(clk) then 
    f<=f_al1;--res_aic8+k;
    if vv < h then 
      
            f<=f_al2;
        
    else
            f<= f_al1; --res_mx- res_aiCB + res_aic8 + cBmh;
        end if;    
    end if;
     
end process;


ff<= -f  when x(n-1)='1'  else  f;  

--process(vv,s,clk)
--begin
--if rising_edge(clk) then 
--    f<=f_al1;--res_aic8+k;
--    if vv < h then 
      
--            f<=f_al1;
        
--    elsif v >= c2alpha then 
--        if ai=c4 then 
--            f<=f_al1;--res_aic8+k;
--        else
--            f<= f_al3; --res_mx- res_aiCB + res_aic8 + cBmh;
--        end if;    
--    end if;
--    end if;
     
--end process;

	




-- 00 (axb)c,
-- 01 (axc)b
-- 10 (cXb)a 

f1_mul: entity work.Multi_axbxc
generic map (	
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>h,
    b=>a,
    c=>x, 
    resul=>f1,
    clk=>clk,
    rst=>rst, 
    comb_sel=>comb_sel(1 downto 0)
);


f2_mul: entity work.Multi_axbxc
generic map (	
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>h,
    b=>b,
    c=>y, 
    resul=>f2,
    clk=>clk,
    rst=>rst, 
    comb_sel=>comb_sel(3 downto 2)
);


f3_mul: entity work.Multi_axbxc
generic map (	
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>h,
    b=>c,
    c=>z, 
    resul=>f3,
    clk=>clk,
    rst=>rst, 
    comb_sel=>comb_sel(5 downto 4)
);


f4_mul: entity work.Multi_axbxc
generic map (	
    n=>n,
    entero=>entero,
    fraccional=>fraccional)
port map(
    a=>h,
    b=>d1,
    c=>ff, 
    resul=>f4,
    clk=>clk,
    rst=>rst, 
    comb_sel=>comb_sel(7 downto 6)
);



x_out<=x;
y_out<=y;
z_out<=z;

end Behavioral;